#!/bin/sh



# check the set addresses in config-expansions file
CAM_I2C_ADRESS_0=$(media-ctl -p | grep -B 7 "> \"ipu1_csi0_mux\"" | grep ar0144 | cut -d: -f2 | cut -c13-14)
CAM_I2C_ADRESS_1=$(media-ctl -p | grep -B 7 "> \"ipu2_csi1_mux\"" | grep ar0144 | cut -d: -f2 | cut -c13-14)
CAM_I2C_BUS=$(find /sys/bus/i2c/drivers/ar0144/ -name "?-00*" | cut -d / -f 7 | cut -c1-1 | sed 2d)

echo ""
echo " camera0 i2c address = $CAM_I2C_ADRESS_0"
echo " camera1 i2c address = $CAM_I2C_ADRESS_1"
echo " i2c bus address = $CAM_I2C_BUS"

# check the devices with "media-ctl -p"
IPU1_CSI0_DEVICE=$(media-ctl -e "ipu1_csi0 capture")
IPU2_CSI1_DEVICE=$(media-ctl -e "ipu2_csi1 capture")
CAM_DEVICE_0=$(media-ctl -e "ar0144 $CAM_I2C_BUS-00$CAM_I2C_ADRESS_0")
CAM_DEVICE_1=$(media-ctl -e "ar0144 $CAM_I2C_BUS-00$CAM_I2C_ADRESS_1")

echo " ipu1_csi0 capture device name = $IPU1_CSI0_DEVICE"
echo " ipu2_csi1 capture device name = $IPU2_CSI1_DEVICE"
echo " camera0 subdevice name = $CAM_DEVICE_0"
echo " camera1 subdevice name = $CAM_DEVICE_1"
echo ""
echo "starting gstreamer with two BAYER Sources ..."
echo "read camera_0 from IPU1_CSI0 and camera_1 from IPU2_CSI1 with 1280 x 800"
echo "write side by side to 2560x1600 Pixel, convert to jpg and write to ar0144_col_dual_image.jpg"
echo "============================================================================================"
echo ""
echo "configure IPU1_CSI0 and IPU2_CSI1 with media_control"
echo "===================================================="

media-ctl -r
media-ctl -l "'ar0144 $CAM_I2C_BUS-00$CAM_I2C_ADRESS_0':0->'ipu1_csi0_mux':1[1]"
media-ctl -l "'ipu1_csi0_mux':2->'ipu1_csi0':0[1]"
media-ctl -l "'ipu1_csi0':2->'ipu1_csi0 capture':0[1]"
#           Camera -> IPU1_CSI0_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)

media-ctl -V "'ar0144 $CAM_I2C_BUS-00$CAM_I2C_ADRESS_0':0 [fmt:SGRBG8_1X8/1280x800 (0,4)/1280x800]"
media-ctl -V "'ipu1_csi0_mux':2 [fmt:SGRBG8_1X8/1280x800]"
media-ctl -V "'ipu1_csi0':2 [fmt:SGRBG8_1X8/1280x800]"

media-ctl -l "'ar0144 $CAM_I2C_BUS-00$CAM_I2C_ADRESS_1':0->'ipu2_csi1_mux':1[1]"
media-ctl -l "'ipu2_csi1_mux':2->'ipu2_csi1':0[1]"
media-ctl -l "'ipu2_csi1':2->'ipu2_csi1 capture':0[1]"
#           Camera -> IPU2_CSI1_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)

media-ctl -V "'ar0144 $CAM_I2C_BUS-00$CAM_I2C_ADRESS_1':0 [fmt:SGRBG8_1X8/1280x800 (0,4)/1280x800]"
media-ctl -V "'ipu2_csi1_mux':2 [fmt:SGRBG8_1X8/1280x800]"
media-ctl -V "'ipu2_csi1':2 [fmt:SGRBG8_1X8/1280x800]"


echo ""
echo "start gstreamer"
echo "==============="

gst-launch-1.0 videomixer name=mix  sink_0::xpos=0 sink_0::ypos=0 sink_1::xpos=1280 sink_1::ypos=0 ! videoconvert ! jpegenc ! multifilesink location=ar0144_col_dual_image.jpg \
	v4l2src num-buffers=5 device=$IPU1_CSI0_DEVICE ! \
	video/x-bayer,format=grbg,depth=8,width=1280,height=800,framerate=30/1 ! queue ! bayer2rgbneon ! videoconvert ! mix. \
	v4l2src num-buffers=5 device=$IPU2_CSI1_DEVICE ! \
	video/x-bayer,format=grbg,depth=8,width=1280,height=800,framerate=30/1 ! queue ! bayer2rgbneon ! videoconvert ! mix.

