#!/bin/sh



# check the set addresses in config-expansions file
CAM_I2C_ADRESS_0=$(media-ctl -p | grep -B 7 "> \"ipu1_csi0_mux\"" | grep vm012 | cut -c19-20)
CAM_I2C_ADRESS_1=$(media-ctl -p | grep -B 7 "> \"ipu2_csi1_mux\"" | grep vm012 | cut -c19-20)
CAM_I2C_BUS=$(find /sys/bus/i2c/drivers/phytec-vm012/ -name "?-00*" | cut -d / -f 7 | cut -c1-1 | sed 2d)

echo ""
echo " camera0 i2c address = $CAM_I2C_ADRESS_0"
echo " camera1 i2c address = $CAM_I2C_ADRESS_1"
echo " i2c bus address = $CAM_I2C_BUS"

# check the devices with "media-ctl -p"
IPU1_CSI0_DEVICE=$(media-ctl -e "ipu1_csi0 capture")
IPU2_CSI1_DEVICE=$(media-ctl -e "ipu2_csi1 capture")
CAM_DEVICE_0=$(media-ctl -e "vm012@$CAM_I2C_ADRESS_0")
CAM_DEVICE_1=$(media-ctl -e "vm012@$CAM_I2C_ADRESS_1")

echo " ipu1_csi0 capture device name = $IPU1_CSI0_DEVICE"
echo " ipu2_csi1 capture device name = $IPU2_CSI1_DEVICE"
echo " camera0 subdevice name = $CAM_DEVICE_0"
echo " camera1 subdevice name = $CAM_DEVICE_1"
echo ""
echo "starting gstreamer with two Bayer COLOR Sources ..."
echo "read camera_0 from CSI0 and camera_1 from CSI1 with 1280 x 1024"
echo "write side by side to 2560x1024 Pixel, convert to jpg and write to vita1300_col_dual_image.jpg"
echo "============================================================================================="
echo ""
echo "configure IPU1_CSI0 and IPU2_CSI1 with media_control"
echo "===================================================="

media-ctl -r
media-ctl -l "'vm012@$CAM_I2C_ADRESS_0':0->'ipu1_csi0_mux':1[1]"
media-ctl -l "'ipu1_csi0_mux':2->'ipu1_csi0':0[1]"
media-ctl -l "'ipu1_csi0':2->'ipu1_csi0 capture':0[1]"
#           Camera -> IPU1_CSI0_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)

v4l2-ctl -d $IPU1_CSI0_DEVICE -c subsampling=0
# Note: Set subsampling is necessary before set resolution

media-ctl -V "'vm012@$CAM_I2C_ADRESS_0':0 [fmt:SRGGB8_1X8/1280x1024 (0,0)/1280x1024]"
media-ctl -V "'ipu1_csi0_mux':2 [fmt:SRGGB8_1X8/1280x1024]"
media-ctl -V "'ipu1_csi0':2 [fmt:SRGGB8_1X8/1280x1024]"

media-ctl -l "'vm012@$CAM_I2C_ADRESS_1':0->'ipu2_csi1_mux':1[1]"
media-ctl -l "'ipu2_csi1_mux':2->'ipu2_csi1':0[1]"
media-ctl -l "'ipu2_csi1':2->'ipu2_csi1 capture':0[1]"
#           Camera -> IPU1_CSI0_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)

v4l2-ctl -d $IPU2_CSI1_DEVICE -c subsampling=0
# Note: Set subsampling is necessary before set resolution

media-ctl -V "'vm012@$CAM_I2C_ADRESS_1':0 [fmt:SRGGB8_1X8/1280x1024 (0,0)/1280x1024]"
media-ctl -V "'ipu2_csi1_mux':2 [fmt:SRGGB8_1X8/1280x1024]"
media-ctl -V "'ipu2_csi1':2 [fmt:SRGGB8_1X8/1280x1024]"

echo ""
echo "start gstreamer"
echo "==============="

gst-launch-1.0 videomixer name=mix  sink_0::xpos=0 sink_0::ypos=0 sink_1::xpos=1280 sink_1::ypos=0 ! videoconvert ! jpegenc ! multifilesink location=vita1300_bw_dual_image.jpg \
   v4l2src num-buffers=1 device=$IPU1_CSI0_DEVICE ! i2c addr=0x$CAM_I2C_ADRESS_0 file=`dirname $0`/../../
   video/x-bayer,format=rggb,depth=8,depth=8,width=1280,height=1024,framerate=25/1 ! vita1300_remapper mode=0 passthrough=false ! \
   bayer2rgbneon ! video/x-raw,width=1280,height=1024 ! videoconvert ! queue ! mix. \
   v4l2src num-buffers=1 device=$IPU2_CSI1_DEVICE ! i2c addr=0x$CAM_I2C_ADRESS_1 file=`dirname $0`/../../   video/x-bayer,format=rggb,depth=8,depth=8,width=1280,height=1024,framerate=25/1 ! vita1300_remapper mode=0 passthrough=false !  \
   bayer2rgbneon ! video/x-raw,width=1280,height=1024 ! videoconvert ! queue ! mix.

echo "File \"vita1300_col_dual_image.jpg\" (format=gray[SRGGB8], 2560x512 Pixel)"

#	Use the i2s plugin only for special register settings, that are not available through v4l2_control.
#register-settings-vita1300.txt show=0 dev=$CAM_DEVICE_0 ! \
#register-settings-vita1300.txt show=0 dev=$CAM_DEVICE_1 ! \
