#!/bin/sh
. `dirname $0`/../../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param



echo "starting gstreamer with $CAM_BW_FMT Source ..."
echo "read $SENSOR_RES (offset x,y=$OFFSET_SENSOR) and write to file bw_$CAMERA-M.raw"
echo "===================================================================================="
echo ""
echo "configure IPU1_CSI0 (camera_0 port) with media_control"
echo "======================================================"

media-ctl -r
media-ctl -l ''$CAM_ENTITY_NUMBER'1 -> "imx6-mipi-csi2":0 [1]'
media-ctl -l "'imx6-mipi-csi2':1->'ipu1_csi0_mux':0 [1]"
media-ctl -l "'ipu1_csi0_mux':2->'ipu1_csi0':0 [1]"
media-ctl -l "'ipu1_csi0':2->'ipu1_csi0 capture':0 [1]"
#           Camera -> iMX6-mipi-csi2 -> IPU1_CSI0_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)

media-ctl -V ''$CAM_ENTITY_NUMBER'1 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES' ('$OFFSET_SENSOR')/'$SENSOR_RES']'
media-ctl -V '"imx6-mipi-csi2":0 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES' field:none]'
media-ctl -V '"imx6-mipi-csi2":1 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES' field:none]'
media-ctl -V '"ipu1_csi0_mux":1 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES' field:none]'
media-ctl -V '"ipu1_csi0_mux":2 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES' field:none]'
media-ctl -V '"ipu1_csi0":0 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES' field:none]'
media-ctl -V '"ipu1_csi0":2 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES' field:none]'


echo ""
echo " configure camera with v4l2_control"
echo " =================================="

v4l2-ctl -d $IPU1_CSI0_DEVICE -c auto_exposure_max=800

echo ""
echo "start gstreamer"
echo "==============="

gst-launch-1.0 \
	v4l2src num-buffers=$NUMBER_OF_PIC device=$IPU1_CSI0_DEVICE $NORM ! \
	video/x-raw,format=GRAY8,depth=8$FRAME_SIZE ! \
	multifilesink location=bw_$CAMERA-M.raw

#	i2c file=`dirname $0`/../register-settings-ar0144.txt show=0 dev=$CAM_DEVICE ! \
#	Use the i2s plugin only for special register settings, that are not available through v4l2_control.

echo "File \"bw_$CAMERA.raw\" ($COL_FORMAT$FRAME_SIZE)"