#!/bin/sh
. `dirname $0`/../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo ""
echo "Attention: Before start the script, set the right IP address for you Host!"
echo "=========================================================================="
echo ""
echo "For show the stream on HOST read the \"readme.txt\""
echo ""
echo "starting gstreamer with $COL_FORMAT Source ..."
echo "read $GRAB_RES (offset x,y=$OFFSET_SENSOR), convert/compress H264 and write to network"
echo "=============================================================================="
echo ""
echo "configure IPU1_CSI0 (camera_0 port) with media_control"
echo "======================================================"

media-ctl -r
media-ctl -l ''$CAM_ENTITY_NUMBER'1 -> "imx6-mipi-csi2":0 [1]'
media-ctl -l "'imx6-mipi-csi2':1->'ipu1_csi0_mux':0 [1]"
media-ctl -l "'ipu1_csi0_mux':2->'ipu1_csi0':0 [1]"
media-ctl -l "'ipu1_csi0':2->'ipu1_csi0 capture':0 [1]"
#           Camera -> iMX6-mipi-csi2 -> IPU1_CSI0_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)

media-ctl -V ''$CAM_ENTITY_NUMBER'1 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' ('$OFFSET_SENSOR')/'$SENSOR_RES_LIVE_DEMO']'
media-ctl -V '"imx6-mipi-csi2":0 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"imx6-mipi-csi2":1 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"ipu1_csi0_mux":1 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"ipu1_csi0_mux":2 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"ipu1_csi0":0 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'
media-ctl -V '"ipu1_csi0":2 [fmt:'$CAM_BW_FMT'/'$GRAB_RES' field:none]'

echo ""
echo " configure camera with v4l2_control"
echo " =================================="

$V4L2_CTRL_CAM0

echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="

gst-launch-1.0 \
	v4l2src device=$IPU1_CSI0_DEVICE $NORM ! \
	video/x-raw,format=GRAY8,depth=8$FRAME_SIZE_LIVE_DEMO$REMAPPER ! \
	videoconvert ! \
	queue ! v4l2h264enc ! \
	rtph264pay config-interval=10 pt=96 ! \
	udpsink host=192.168.2.7 port=5200

#	i2c file=$REG_SET_FILE show=0 dev=$CAM_DEVICE ! \
#	Use the i2s plugin only for special register settings, that are not available through v4l2_control.
