#!/bin/sh
# Run OpenCV phyCAM scripts on your Arm-based Linux computer.
# Copyright (C) 2019 PHYTEC, Mainz, Germany

echo ""
echo " If the first start after reboot, an initialize of media-ctl is necessary"
echo " ========================================================================"
echo " 1 = monochrome camera @ Cam_0 (phyCAM-P/-S) port"
echo " 2 = color camera @ CAM_0 (phyCAM-P/-S) port"
echo " 3 = monochrome camera @ Cam_2 (phyCAM-M) port"
echo " 4 = color camera @ CAM_2 (phyCAM-M) port"
echo " 5 = initialize done"
read SET_MEDIA_CTL
echo " Your select = $SET_MEDIA_CTL"
case $SET_MEDIA_CTL in
  "1") ./init_bw_phyCAM_v4l_device.sh ;;
  "2") ./init_col_phyCAM_v4l_device.sh ;;
  "3") ./init_bw_phyCAM-M_v4l_device.sh ;;
  "4") ./init_col_phyCAM-M_v4l_device.sh ;;
  "5") ;;
  *) ;;
esac

export DISPLAY=:0.0
IPU1_CSI0_DEVICE=$(media-ctl -e "ipu1_csi0 capture")

echo " Choose the example script"
echo " ========================="
echo " 1 = show edge detect on live stream"
echo " 2 = show live stream, is a USB keyboard present save a jpg image"
read SET_CHOOSE_SCRIPT
echo " Your select = $SET_CHOOSE_SCRIPT"
case $SET_CHOOSE_SCRIPT in
  "1") /usr/share/OpenCV/samples/bin/example_cpp_application_trace $IPU1_CSI0_DEVICE -n 25 ;;
  "2") /usr/share/OpenCV/samples/bin/example_cpp_videocapture_starter $IPU1_CSI0_DEVICE ;;
  *) /usr/share/OpenCV/samples/bin/example_cpp_application_trace $IPU1_CSI0_DEVICE -n 25 ;;
esac
